# Conditional build:
%bcond_without	doc	# API documentation
%bcond_without	tests	# unit tests

%define		module	propcache
Summary:	Accelerated property cache
Name:		python3-%{module}
Version:	0.2.1
Release:	6
License:	Apache
Group:		Libraries/Python
Source0:	https://pypi.debian.net/%{module}/%{module}-%{version}.tar.gz
# Source0-md5:	c642caac1415818205011277008142ea
URL:		https://pypi.org/project/propcache/
BuildRequires:	python3-Cython
BuildRequires:	python3-build
BuildRequires:	python3-expandvars
BuildRequires:	python3-installer
BuildRequires:	python3-modules >= 1:3.9
%if %{with tests}
BuildRequires:	python3-covdefaults
BuildRequires:	python3-mdit-py-plugins
BuildRequires:	python3-pytest-benchmark
BuildRequires:	python3-pytest_codspeed
BuildRequires:	python3-pytest-xdist
%endif
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 2.044
%if %{with doc}
BuildRequires:	python3-sphinxcontrib-towncrier
BuildRequires:	sphinx-pdg-3
%endif
Requires:	python3-modules >= 1:3.2
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
The module provides a fast implementation of cached properties for
Python 3.9+.

%package apidocs
Summary:	API documentation for Python %{module} module
Summary(pl.UTF-8):	Dokumentacja API modułu Pythona %{module}
Group:		Documentation

%description apidocs
API documentation for Python %{module} module.

%description apidocs -l pl.UTF-8
Dokumentacja API modułu Pythona %{module}.

%prep
%setup -q -n %{module}-%{version}

# keep *.c files so debuginfo will pick it up
sed -i -e 's#build_inplace: bool = False,#build_inplace: bool = True,#g' -e 's#build_inplace=False#build_inplace=True#g' packaging/pep517_backend/_backend.py

%build
%py3_build_pyproject

%if %{with tests}
%{__python} -m zipfile -e build-3/*.whl build-3-test
# use explicit plugins list for reliable builds (delete PYTEST_PLUGINS if empty)
PYTEST_DISABLE_PLUGIN_AUTOLOAD=1 \
PYTEST_PLUGINS=pytest_codspeed,xdist,benchmark \
%{__python3} -m pytest -o pythonpath="$PWD/build-3-test" tests
%endif

%if %{with doc}
%{__python} -m zipfile -e build-3/*.whl build-3-doc
export PYTHONPATH="$PWD/build-3-doc"
%{__make} -C docs html \
	SPHINXBUILD=sphinx-build-3
rm -rf docs/_build/html/_sources
%endif

%install
rm -rf $RPM_BUILD_ROOT

%py3_install_pyproject

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc CHANGES.rst README.rst
%dir %{py3_sitedir}/%{module}
%{py3_sitedir}/%{module}/*.py
%{py3_sitedir}/%{module}/*.pyx
%{py3_sitedir}/%{module}/py.typed
%{py3_sitedir}/%{module}/__pycache__
%attr(755,root,root) %{py3_sitedir}/%{module}/*.so
%{py3_sitedir}/%{module}-%{version}.dist-info

%if %{with doc}
%files apidocs
%defattr(644,root,root,755)
%doc docs/_build/html/*
%endif
%changelog
* Wed Mar 12 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python3-propcache.git;a=log;h=auto/th/python3-propcache-0.2.1-6

* Tue Mar 11 2025 Jan Rękorajski <baggins@pld-linux.org> d7f7b28
- doc/test rebuild for python 3.13

* Mon Mar 10 2025 Jan Rękorajski <baggins@pld-linux.org> eb82f3c
- python 3.13 rebuild

* Wed Feb 19 2025 Arkadiusz Miśkiewicz <arekm@maven.pl> 443a123
- Rel 4; keep cythonized .c files for debuginfo

* Mon Feb 17 2025 Arkadiusz Miśkiewicz <arekm@maven.pl> b69c44c
- Typo.

* Mon Feb 17 2025 Arkadiusz Miśkiewicz <arekm@maven.pl> a5de92e
- Rel 3; more BR

* Mon Feb 17 2025 Arkadiusz Miśkiewicz <arekm@maven.pl> 8443332
- Rel 2; more BR and fix docs build

* Mon Feb 10 2025 Arkadiusz Miśkiewicz <arekm@maven.pl> 1c21678
- Fix tests

* Sat Feb 08 2025 Arkadiusz Miśkiewicz <arekm@maven.pl> 926fed4
- Initial

